package com.github.gkutiel.fblogin;

import java.util.concurrent.TimeUnit;

import com.github.gkutiel.fbi.FbApp;
import com.github.gkutiel.fbi.FbApp.Client;
import com.github.gkutiel.fbi.FbApp.FbLoginException;
import com.github.gkutiel.fbi.FbApp.Permission;
import com.github.gkutiel.fbi.Fbi;
import com.github.gkutiel.fbi.Fbi.FbiResponseException;
import com.github.gkutiel.fbi.obj.FbUser;
import com.github.gkutiel.filter.Filter;

public class FbLogin extends Filter {

	private final FbApp app;

	@Param String code;

	@Cookie protected FbUser fbUser;
	@Cookie String accessToken;

	protected Fbi fbi;

	public FbLogin(final Client client, final Permission... permissions) {
		app = new FbApp(client, permissions);
	}

	@Override
	public void apply() {
		try {
			if (fbUser != null && accessToken != null) {
				fbi = new Fbi(accessToken);
				return;
			}

			final String url = url();
			if (code == null) redirect(app.fbLoginPage(url));

			accessToken = app.getAccessTokenFromFb(code, url);
			fbi = new Fbi(accessToken);
			fbUser = fbi.me().go();

			final int seconds = (int) TimeUnit.DAYS.toSeconds(1);
			set("accessToken", accessToken);
			set("fbUser", fbUser, seconds);

		} catch (final FbLoginException | FbiResponseException e) {
			throw new RuntimeException(e);
		}
	}
}
